/*
 * proprietary code?
 */

/******************************************************************************/
/*                                                                            */
/*      Copyright (c) 1987, Sun Microsystems Inc., Raleigh, North Carolina    */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
/* @(#)tardwr.c	1.8 89/10/27 */
#ifndef lint
static char sccs_id[]="@(#)tardwr.c	1.8.1.1 90/11/07 Copyr 1987 Sun Micro";
#endif

#include <sys/mman.h>
#include <sys/file.h>
#include <taac1/taio.h>

/* ........ */
/* ........ */

/* 15 MAY 87 */
/***************************************************************/
/* set the slave mode register for a certain local bus address */
/***************************************************************/
int ta_use_map_2d(tahandle,lbaddress)
TA_HANDLE *tahandle;
int lbaddress;
{
int readback;

	if ((readback= ta_readsmr(tahandle)) == -1) return(TA_FAILURE);
	if ((lbaddress & 0xFFC00000)==0) {
		if (ta_writesmr(tahandle, (readback & ~(TA_PAGEBITS) | TA_TWODIM|TA_PAGE0)) == -1) return(TA_FAILURE);
	} else if ((lbaddress & 0xFFC00000) == 0x20000000) {
		if (ta_writesmr(tahandle, (readback & ~(TA_PAGEBITS) | TA_TWODIM|TA_PAGE1)) == -1) return(TA_FAILURE);
	} else if ((lbaddress & 0xFFC00000) == 0x30000000) {
		if (ta_writesmr(tahandle, (readback & ~(TA_PAGEBITS) | TA_TWODIM|TA_PAGE2)) == -1) return(TA_FAILURE);
	} else if ((lbaddress & 0xFFC00000) == 0x38000000) {
		if (ta_writesmr(tahandle, (readback & ~(TA_PAGEBITS) | TA_TWODIM|TA_PAGE3)) == -1) return(TA_FAILURE);
	} else {
		return(TA_FAILURE);
	}
}
